org.apache.hc.core5.reactor

## Class DefaultListeningIOReactor

- java.lang.Object
- - org.apache.hc.core5.reactor.DefaultListeningIOReactor

- All Implemented Interfaces:
    Closeable, AutoCloseable, ModalCloseable, ConnectionAcceptor, ConnectionInitiator, IOReactor, IOReactorService

      public class DefaultListeningIOReactor
      extends Object
      implements ConnectionAcceptor

  Multi-core I/O reactor that can act as both `ConnectionInitiator` and `ConnectionAcceptor`. Internally this I/O reactor distributes newly created I/O session equally across multiple I/O worker threads for a more optimal resource utilization and a better I/O performance. Usually it is recommended to have one worker I/O reactor per physical CPU core.
  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory)` Creates an instance of DefaultListeningIOReactor with default configuration.
    `DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory, IOReactorConfig config, Callback<IOSession> sessionShutdownCallback)` Creates an instance of DefaultListeningIOReactor with the given configuration.
    `DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory, IOReactorConfig ioReactorConfig, ThreadFactory dispatchThreadFactory, ThreadFactory listenerThreadFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, Callback<IOSession> sessionShutdownCallback)` Creates an instance of DefaultListeningIOReactor with the given configuration.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `awaitShutdown(TimeValue waitTime)` Blocks for the given period of time in milliseconds awaiting the completion of the reactor shutdown.
    `void` | `close()`
    `void` | `close(CloseMode closeMode)` Shuts down the I/O reactor either gracefully or immediately.
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `Set<ListenerEndpoint>` | `getEndpoints()` Returns a set of endpoints for this I/O reactor.
    `IOReactorStatus` | `getStatus()` Returns the current status of the reactor.
    `void` | `initiateShutdown()` Initiates shutdown of the reactor without blocking.
    `Future<ListenerEndpoint>` | `listen(SocketAddress address)`
    `Future<ListenerEndpoint>` | `listen(SocketAddress address, FutureCallback<ListenerEndpoint> callback)` Opens a new listener endpoint with the given socket address.
    `Future<ListenerEndpoint>` | `listen(SocketAddress address, Object attachment, FutureCallback<ListenerEndpoint> callback)`
    `void` | `pause()` Suspends the I/O reactor preventing it from accepting new connections on all active endpoints.
    `void` | `resume()` Resumes the I/O reactor restoring its ability to accept incoming connections on all active endpoints.
    `void` | `start()` Starts I/O reactor.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultListeningIOReactor

          public DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory,
                                   IOReactorConfig ioReactorConfig,
                                   ThreadFactory dispatchThreadFactory,
                                   ThreadFactory listenerThreadFactory,
                                   Decorator<IOSession> ioSessionDecorator,
                                   Callback<Exception> exceptionCallback,
                                   IOSessionListener sessionListener,
                                   Callback<IOSession> sessionShutdownCallback)

      Creates an instance of DefaultListeningIOReactor with the given configuration.
      Parameters:
        `eventHandlerFactory` - the factory to create I/O event handlers.
        `ioReactorConfig` - I/O reactor configuration.
        `listenerThreadFactory` - the factory to create listener thread. Can be `null`.
      Since:
        5.0

    - #### DefaultListeningIOReactor

          public DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory,
                                   IOReactorConfig config,
                                   Callback<IOSession> sessionShutdownCallback)

      Creates an instance of DefaultListeningIOReactor with the given configuration.
      Parameters:
        `eventHandlerFactory` - the factory to create I/O event handlers.
        `config` - I/O reactor configuration. Can be `null`.
      Since:
        5.0

    - #### DefaultListeningIOReactor

          public DefaultListeningIOReactor(IOEventHandlerFactory eventHandlerFactory)

      Creates an instance of DefaultListeningIOReactor with default configuration.
      Parameters:
        `eventHandlerFactory` - the factory to create I/O event handlers.
      Since:
        5.0

  - ### Method Detail

    - #### start

          public void start()

      Description copied from interface: `IOReactorService`
      Starts I/O reactor.
      Specified by:
        `start` in interface `IOReactorService`

    - #### listen

          public Future<ListenerEndpoint> listen(SocketAddress address,
                                        Object attachment,
                                        FutureCallback<ListenerEndpoint> callback)

    - #### listen

          public Future<ListenerEndpoint> listen(SocketAddress address,
                                        FutureCallback<ListenerEndpoint> callback)

      Description copied from interface: `ConnectionAcceptor`
      Opens a new listener endpoint with the given socket address. Once the endpoint is fully initialized it starts accepting incoming connections and propagates I/O activity notifications to the I/O event dispatcher.
      Specified by:
        `listen` in interface `ConnectionAcceptor`
      Parameters:
        `address` - the socket address to listen on.
        `callback` - the result callback.
      Returns:
        listener endpoint.

    - #### listen

          public Future<ListenerEndpoint> listen(SocketAddress address)

    - #### getEndpoints

          public Set<ListenerEndpoint> getEndpoints()

      Description copied from interface: `ConnectionAcceptor`
      Returns a set of endpoints for this I/O reactor.
      Specified by:
        `getEndpoints` in interface `ConnectionAcceptor`
      Returns:
        set of endpoints.

    - #### pause

          public void pause()
                     throws IOException

      Description copied from interface: `ConnectionAcceptor`
      Suspends the I/O reactor preventing it from accepting new connections on all active endpoints.
      Specified by:
        `pause` in interface `ConnectionAcceptor`
      Throws:
        `IOException` - in case of an I/O error.

    - #### resume

          public void resume()
                      throws IOException

      Description copied from interface: `ConnectionAcceptor`
      Resumes the I/O reactor restoring its ability to accept incoming connections on all active endpoints.
      Specified by:
        `resume` in interface `ConnectionAcceptor`
      Throws:
        `IOException` - in case of an I/O error.

    - #### getStatus

          public IOReactorStatus getStatus()

      Description copied from interface: `IOReactor`
      Returns the current status of the reactor.
      Specified by:
        `getStatus` in interface `IOReactor`
      Returns:
        reactor status.

    - #### initiateShutdown

          public void initiateShutdown()

      Description copied from interface: `IOReactor`
      Initiates shutdown of the reactor without blocking. The reactor is expected to terminate all active connections, to shut down itself and to release system resources it currently holds
      Specified by:
        `initiateShutdown` in interface `IOReactor`

    - #### awaitShutdown

          public void awaitShutdown(TimeValue waitTime)
                             throws InterruptedException

      Description copied from interface: `IOReactor`
      Blocks for the given period of time in milliseconds awaiting the completion of the reactor shutdown.
      Specified by:
        `awaitShutdown` in interface `IOReactor`
      Parameters:
        `waitTime` - wait time.
      Throws:
        `InterruptedException`

    - #### close

          public void close(CloseMode closeMode)

      Description copied from interface: `IOReactor`
      Shuts down the I/O reactor either gracefully or immediately. During graceful shutdown individual I/O sessions should be informed about imminent termination and be given a grace period to complete the ongoing I/O sessions. During immediate shutdown all ongoing I/O sessions get aborted immediately.
      Specified by:
        `close` in interface `ModalCloseable`
      Specified by:
        `close` in interface `IOReactor`
      Parameters:
        `closeMode` - How to close the receiver.

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `IOException`

    - #### connect

          public final Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                  SocketAddress remoteAddress,
                                  SocketAddress localAddress,
                                  Timeout timeout,
                                  Object attachment,
                                  FutureCallback<IOSession> callback)
                                          throws IOReactorShutdownException

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.
      Throws:
        `IOReactorShutdownException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.